/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: WLan-monitor
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2001-09-02, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  *       - added events
  *       - added nwid
  * -------------------------------------------------------------------
  * TODO:
  */
package jaugment2.wlanmonitor;

  //JDK
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.MarshalledObject;
  //JINI
import net.jini.core.lease.LeaseDeniedException;
import net.jini.core.lease.UnknownLeaseException;
import net.jini.core.lease.Lease;
import net.jini.core.event.RemoteEvent;
import net.jini.core.event.RemoteEventListener;
import net.jini.core.event.UnknownEventException;


/**
 * Title:        WLan-Monitor
 * Description:  Monitors wireless-lan link-quality
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Marcus Wolschon Suran@gmx.net
 * @version 1.0
 */

public interface WLanMonitorProxyIF extends Remote
{
 public abstract float getLink() throws RemoteException;
 public abstract float getNoise() throws RemoteException;
 public abstract float getLevel() throws RemoteException;
 public abstract String getNWID() throws RemoteException;

  /** Subscribe for event
    */
 public Lease addListener(RemoteEventListener listener, MarshalledObject handback, int registerfor) throws RemoteException, LeaseDeniedException, IllegalStateException;


 public static class WLanMonitorEvent extends RemoteEvent
 {
  public static final int EVID_LINKLEVELUPDATED = 1;
  public float level;
  public float link;
  public float noise;
  public String nwid;

  public WLanMonitorEvent(Object proxy, long eventID, long seqNum, MarshalledObject handback, float level, float link, float noise, String nwid)
  {
   super(proxy, eventID, seqNum, handback);
   this.level = level;
   this.link  = link;
   this.noise = noise;
   this.nwid  = nwid;
  }


 }

}